/* LDVINTFC.H -- LONWORKS standard network interface functions.
 * Copyright (c) 1993 by Echelon Corporation.
 * All Rights Reserved.
 *
 * Date last modified: 10/7/93
 *
 *
 ****************************************************************************
 * Network driver error codes.
 ****************************************************************************
 */

typedef enum {
    LDV_OK = 0,
    LDV_NOT_FOUND,
    LDV_ALREADY_OPEN,
    LDV_NOT_OPEN,
    LDV_DEVICE_ERR,
    LDV_INVALID_DEVICE_ID,
    LDV_NO_MSG_AVAIL,
    LDV_NO_BUFF_AVAIL,
    LDV_DEVICE_BUSY
} LDVCode;

/*
 ****************************************************************************
 * Standard network driver functions.
 ****************************************************************************
 */

typedef int LNI;          // device handle

LNI ldv_open( const char * device_name );
            /* Open network interface device - returns device handle */

LDVCode ldv_read( LNI handle, void * msg_p, unsigned length );
            /* Read a buffer */

LDVCode ldv_write( LNI handle, void * msg_p, unsigned length );
            /* Write a buffer */

LDVCode ldv_close( LNI handle );
           /* Close network interface device */
