#include <windows.h>
#include <tchar.h>
#include <stdio.h>
#include <conio.h>
#include <ctype.h>
#include <fcntl.h>
#include <io.h>
#include "wldv32.h"

void Notify();
int handle, res, i;
char buf[ 64 ];



HMODULE WINAPI LoadLibraryShared(IN LPCSTR lpLibFileName)
    {
    HMODULE hDll = NULL;
    TCHAR gszHKLMAppPathKey[]   = "Software\\Microsoft\\Windows\\CurrentVersion\\App Paths";
    CHAR    KeyName[MAX_PATH];
    DWORD   dwMaxPath;
    DWORD   ret;
	DWORD   type;
    HKEY    hKey, dllKey;

    ret = RegOpenKeyEx( HKEY_LOCAL_MACHINE, gszHKLMAppPathKey, 0, KEY_READ, &hKey);
    if (ret == ERROR_SUCCESS)
        {
        ret = RegOpenKeyEx( hKey, lpLibFileName, 0, KEY_READ, &dllKey);
        if (ret == ERROR_SUCCESS)
            {
            dwMaxPath = MAX_PATH;
            ret = RegQueryValueEx(dllKey, NULL, NULL, &type, (LPBYTE)KeyName, &dwMaxPath);
            if (ret == ERROR_SUCCESS)
                {
                hDll = LoadLibrary(KeyName);
                }
            RegCloseKey(dllKey) ;
            }
        RegCloseKey(hKey) ;
        }
    if (!hDll)
        hDll = LoadLibrary(lpLibFileName);
    return hDll;
    }

WLDV_GET_VERSION pldv_get_version = NULL;  // ldv_open;
WLDV_OPEN        pldv_open        = NULL;  // ldv_open;
WLDV_CLOSE       pldv_close       = NULL;  // ldv_close;
WLDV_READ        pldv_read        = NULL;  // ldv_read;
WLDV_WRITE       pldv_write       = NULL;  // ldv_write;
WLDV_REGISTER    pldv_register    = NULL;  // ldv_register;
WLDV_DEBUGMODE   pldv_debugmode   = NULL;  // ldv_debugmode
WLDV_NEURONID    pldv_neuronID    = NULL;  // ldv_neuronID


HMODULE WINAPI LoadWldv32()
    {
    HMODULE hLdvDll = LoadLibraryShared("WLDV32.DLL");
    if (hLdvDll)
        {
        pldv_get_version = (WLDV_GET_VERSION) GetProcAddress(hLdvDll, "_ldv_get_version@0");
        pldv_open        = (WLDV_OPEN)        GetProcAddress(hLdvDll, "_ldv_open@4");
        pldv_close       = (WLDV_CLOSE)       GetProcAddress(hLdvDll, "_ldv_close@4");
        pldv_read        = (WLDV_READ)        GetProcAddress(hLdvDll, "_ldv_read@12");
        pldv_write       = (WLDV_WRITE)       GetProcAddress(hLdvDll, "_ldv_write@12");
        pldv_register    = (WLDV_REGISTER)    GetProcAddress(hLdvDll, "_ldv_register@8");
        pldv_debugmode   = (WLDV_DEBUGMODE)   GetProcAddress(hLdvDll, "_ldv_debugmode@8");
        pldv_neuronID    = (WLDV_NEURONID)    GetProcAddress(hLdvDll, "_ldv_neuronID@4");
  
        if (pldv_get_version && pldv_open && pldv_close && pldv_read && pldv_write && pldv_register)
            return hLdvDll;
        FreeLibrary(hLdvDll);
        }
    return NULL;
    }


int Test(LPSTR Name)
    {
    LPSTR Version;
    //          handle = pldv_open("LDV/\\\\.\\lonpcc10"  ) ;
    handle = pldv_open(Name);
    printf( "ldv_open(%s)=%d\n", Name, handle ) ;
    
    if(handle != LDV_OK) return 1 ;
    pldv_register( handle, Notify ) ;
    
    Version = pldv_get_version();
    printf( "ldv_get_version()=%s\n", Version) ;
    
    // initialize query_status command
    buf[0] = 0x22;
    buf[1] = 0x0f;
    buf[2] = 0x61;
    buf[3] = 0x08;
    buf[4] = 0x01;
    for(i = 5 ; i < 16 ; i++) buf[i] = 0;
    buf[16] = 0x51;
    
//    Sleep(2000);
    res = pldv_write( handle, buf, 17 ) ;
#if 0    
    Sleep(3000);
#else
    do  {
        res = pldv_read( handle, buf, sizeof( buf ) );
        if (res == LDV_OK)
            printf("pldv_read(): Id=%02X Len=%02X\n", buf[0], buf[1]);
         else if (res != LDV_NO_MSG_AVAIL)
            printf("pldv_read()=%d\n", res);

        } while ( res == LDV_NO_MSG_AVAIL );
#endif
    pldv_close(handle);
    return 0;
    }


int main(int argc, char* argv[])
    {
    HMODULE hLdvDll;
    LPSTR Name = "LDV/\\\\.\\lonusb1-1";
    if (argc > 1)
        Name = argv[1];


    hLdvDll = LoadWldv32();

    if (hLdvDll)
        {
        pldv_debugmode("Debug.LOG", 1);
#if 01
//        Test("LDV/\\\\.\\LONPCC10");
        Test("LDV/\\\\.\\lppwdm0-14");
        Test("SLTA/1:57600");
        Test("SLTA/2:115200");
#else
        Test("LDV/\\\\.\\lonusb1-0");
        Test(Name);
        Test(Name);
        Test("LDV/\\\\.\\lonusb1-99");
        Test(Name);
        Test(Name);
#endif
        }
//    else 
//        return 1;


//    Sleep(3000);

    if (hLdvDll)
        {
        FreeLibrary(hLdvDll);
        hLdvDll = NULL;
        }
    
//    for (;;)
//        Sleep(1000);

    return 0 ;
    }

void Notify() 
    {
    printf("Notify():\n");
#if 0
    res = pldv_read( handle, buf, sizeof( buf ) );
    if (res == LDV_OK)
        printf("pldv_read(): Id=%02X Len=%02X\n", buf[0], buf[1]);
    else 
        printf("pldv_read()=%d\n", res);
#endif
	return ;
    }